"""pyXGTClient package Constants Definition """
# Package Version
VERSION = '0.0.1'
#XGT Protocol 
XGT_PORT = 2004
#XGT Protocol CompanyID
XGT_COMPANYID = "LSIS-XGT"

#XGT CAMMAND
XGT_CMD_RD = 0x54
XGT_CMD_RD_ACK = 0x55
XGT_CMD_WR = 0x58
XGT_CMD_WR_ACK = 0x59

#XGT_DATATYPE
XGT_DATA_BIT = 0x00
XGT_DATA_BYTE = 0x01
XGT_DATA_WORD = 0x02
XGT_DATA_DWORD = 0x03
XGT_DATA_LWORD = 0x04
XGT_DATA_CONTINUOUS=0x14

#XGT Header Position
XGT_HEADER_PLCINFO = 10
XGT_HD_PLCINFO = 10
XGT_HD_CPUINFO = 12
XGT_HD_SOURCEOFFRAME = 13
XGT_HD_INVOKEID = 14
XGT_HD_LENGTH = 16
XGT_HD_FENETPOSITION = 18
XGT_HD_CHECKSUM = 19
XGT_HD_COMMAND = 20
XGT_HD_DATATYPE = 22
XGT_HD_BLOCKCNT = 26
XGT_HD_VARNAMELEN = 28
XGT_HD_DATALEN = 30

XGT_MAX_ARRAYSIZE = 1000
XGT_MAX_BLOCK_COUNT = 16
XGT_MAX_BLOCKNAMESIZE = 16

#XGT Protocol Status Code
XGT_STATUS_TST_OK = 1
XGT_STATUS_NOT_CONNECTED = -1
XGT_STATUS_SIZE_OVER = -2
XGT_STATUS_INVOKEDID = -3
XGT_STATUS_NAK = -4
XGT_STATUS_WRITE_DATA_UNMATCH = -5
XGT_STATUS_DATATYPE =-6
XGT_STATUS_CONNECT_ERR = -7
XGT_STATUS_SEND_ERR = -8
XGT_STATUS_RECV_ERR = -9
XGT_STATUS_TIMEOUT_ERR = -10
XGT_STATUS_SOCK_CLOSE_ERR = -11

STATUS_TXT = {
    XGT_STATUS_TST_OK: 'OK',
    XGT_STATUS_NOT_CONNECTED: 'NotConnected',
    XGT_STATUS_SIZE_OVER:'SizeOver',
    XGT_STATUS_INVOKEDID: 'InvokedID Not Match',
    XGT_STATUS_NAK: 'NAK',
    XGT_STATUS_WRITE_DATA_UNMATCH:'WriteDataUnMatch',
    XGT_STATUS_DATATYPE:'DataType Error',       
    XGT_STATUS_CONNECT_ERR: 'connect error',
    XGT_STATUS_SEND_ERR: 'socket send error',
    XGT_STATUS_RECV_ERR: 'socket recv error',
    XGT_STATUS_TIMEOUT_ERR: 'recv timeout occur',      
    XGT_STATUS_SOCK_CLOSE_ERR: 'socket is closed'
}

XGT_DATATYPE_DIC={
    'X':XGT_DATA_BIT,
    'B':XGT_DATA_BYTE,
    'W':XGT_DATA_WORD,
    'D':XGT_DATA_DWORD,
    'L':XGT_DATA_LWORD,    
}
